#ifndef _AUDIOTEST_H_
#define _AUDIOTEST_H_

#include <zephyr/types.h>
#include <stddef.h>
#include <string.h>
#include <errno.h>
#include <sys/printk.h>
#include <sys/byteorder.h>
#include <zephyr.h>
//#include <irq.h>

#include <device.h>
#include <disk/disk_access.h>
#include <storage/flash_map.h>
#include <fs/fs.h>
#include <ff.h>

#include <logging/log.h>

#include <stdio.h>

#include <bluetooth/bluetooth.h>
#include <bluetooth/hci.h>
#include <bluetooth/conn.h>
#include <bluetooth/uuid.h>
#include <bluetooth/gatt.h>

#include <hal/nrf_gpio.h>
//#include <nrfx_gpio.h>
#include <nrfx_gpiote.h>
#include <nrfx_twim.h>
#include <nrfx_i2s.h>

#include "twimMgr.h"



typedef struct {
  void                  *fifo_reserved;   // Required by Zephyr FIFO
  struct bt_conn        *conn;            // Connection to send to
  struct bt_gatt_attr   *characteristic;  // Characteristic to send
  int                   len;              // length of data to send
  void                  *data;            // Data being sent
} bleSendQueueItem;

extern uint32_t bleNotificationsAvailable;

extern struct bt_conn *bleCurrentConnection;
extern struct k_fifo  notifyQueue;
extern int    twimContext; 

// Interrupt level definitions
#define GPIO_INTERRUPT_LEVEL    5

// Pin definitions

// For nRF52840-DK
#if 0
#define I2C_SCL_PIN             (NRF_GPIO_PIN_MAP(0,27))
#define I2C_SDA_PIN             (NRF_GPIO_PIN_MAP(0,26))
#endif

// For nRF5340-DK
#if 1
#define I2C_SCL_PIN             (NRF_GPIO_PIN_MAP(1,3))
#define I2C_SDA_PIN             (NRF_GPIO_PIN_MAP(1,2))
#endif

#define I2S_SCK_PIN             (NRF_GPIO_PIN_MAP(0,28))
#define I2S_LRCK_PIN            (NRF_GPIO_PIN_MAP(0,29))
#define I2S_MCK_PIN             (NRF_GPIO_PIN_MAP(0,30))
#define I2S_SDIN_PIN            (NRF_GPIO_PIN_MAP(0,25))

#endif // _AUDIOTEST_H_
